#!/usr/bin/python
#
# daemon.py - SAKU daemon module.
# Copyright (C) 2005  shinGETsu Project.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: daemon.py,v 1.2 2005/04/12 14:32:45 fuktommy Exp $
#

import os
import sys
import time

import config
import httpd
import crond

__version__ = "$Revision: 1.2 $"

class Logger:

    """Save logs to /LOGDIR/%Y-%m-%d."""

    def __init__(self, logdir):
        self.logdir = logdir
        self.logfile = ""
        self.output = None

    def write(self, msg):
        newlog = self.logdir + "/" + \
                 time.strftime("%Y-%m-%d", time.localtime())
        if self.logfile == newlog:
            pass
        elif self.logfile == "":
            self.logfile = newlog
            self.output = file(self.logfile, "a")
        else:
            self.output.close()
            self.logfile = newlog
            self.output = file(self.logfile, "a")
        self.output.write(msg)
        self.output.flush()

    def flush(self):
        pass

    def close(self):
        self.output.close()

def setup():
    config.flags.append("light_cgi")
    for i in [os.path.join(config.docroot, j) for j in \
                (config.run_dir, config.cache_dir)] + \
             [config.log_dir]:
        if not os.path.isdir(i):
            os.makedirs(i)

def set_logger():
    logger = Logger(os.path.join(os.getcwd(), config.log_dir))
    sys.stderr = logger
    sys.stdout = logger

def start_daemon():
    crondaemon = crond.Crond()
    crondaemon.setDaemon(True)
    crondaemon.start()

    httpdaemon = httpd.Httpd()
    httpdaemon.setDaemon(True)
    httpdaemon.start()
