#!/usr/bin/python
#
# tksaku.py - shinGETsu clone with Tk interface.
# Copyright (C) 2005  shinGETsu Project.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: tksaku.pyw,v 1.4 2005/04/12 06:36:43 fuktommy Exp $
#

import os
import sys
from Tkinter import *
from ScrolledText import ScrolledText

import shingetsu.daemon as daemon
import shingetsu.config as config

__version__ = "$Revision: 1.4 $"

class Sakutk(Frame):
    def createWidgets(self):
        self.master.title(u"SAKU/Tk")

        self.TOP = Frame(self)
        self.TOP.pack(side="top")

        self.LABEL = Label(self.TOP, text=u"SAKU/Tk")
        self.LABEL.pack(side="left")

        self.STOP = Button(self.TOP, text="STOP", command=sys.exit)
        self.STOP.pack(side="right")

        self.TEXT = ScrolledText(self, width=80, height=25, state=DISABLED)
        self.TEXT.pack(expand=True, fill=BOTH)

    def __init__(self, master=None):
        Frame.__init__(self, master)
        self.pack(expand=True, fill=BOTH)
        self.createWidgets()

class Logger(daemon.Logger):

    """Save logs to /LOGDIR/%Y-%m-%d and output Tk textarea."""

    def __init__(self, logdir, textarea):
        daemon.Logger.__init__(self, logdir)
        self.textarea = textarea
        self.linesize = 0

    def write(self, msg):
        daemon.Logger.write(self, msg)
        self.linesize += 1
        self.textarea.config(state=NORMAL)
        while config.tklog < self.linesize:
            self.linesize -= 1
            self.textarea.delete("1.0", "2.0")
        try:
            self.textarea.insert(END, unicode(msg, "utf-8"))
        except UnicodeError:
            pass
        self.textarea.config(state=DISABLED)
        self.textarea.yview(END)

    def flush(self):
        pass

    def close(self):
        self.output.close()

def set_logger(textarea):
    logger = Logger(os.path.join(os.getcwd(), config.log_dir), textarea)
    sys.stderr = logger
    sys.stdout = logger

def main():
    try:
        daemon.setup()
        app = Sakutk()
        set_logger(app.TEXT)
        daemon.start_daemon()
        app.mainloop()
    except KeyboardInterrupt:
        sys.exit()

if __name__ == "__main__":
    main()
